const uuid = require("uuid");
const fs = require("fs");
const path = require("path");

const express = require("express");
let app = express();
let port = process.env.PORT || 4000;

const config = JSON.parse(fs.readFileSync(path.resolve("config", "config.json")));
let host = config.host;

let app_name = config.app.name;
let app_callback = config.app.callback;
let app_permission = config.app.permission;

// https://misskey.io/miauth/c1f6d42b-468b-4fd2-8274-e58abdedef6f?name=MyApp&callback=https%3A%2F%2Fmyapp.example.com%2Fcallback&permission=write:notes,write:following,read:drive

let session_id = uuid.v4();
let auth_url = `${host}/miauth/${session_id}?name=${app_name}&callback=${app_callback}&permission=${app_permission}`;
let auth_status = 0;

console.log(auth_url);

app.get('/callback', function(req, res) {
    res.send({
        "status": 200,
        "success": true,
    })

    auth_status = 1;
});

async function check_auth_status() {
    setInterval(() => {
        console.log("Checking auth status...");

        if(auth_status == 1) {
            console.log("Bot has been authenticated");
            clearInterval(check_auth_status);
            return true;
        }
    }, 2000);
};

async function get_access_token() {
    
}

app.listen(port);
console.log(`Callback URL: http://localhost:${port}/callback`);